#include "stdafx.h"
#include "Toast.h"
#include "ToastDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

class CAboutDlg : public CDialog
{
public:
  CAboutDlg();

  enum { IDD = IDD_ABOUTBOX };

protected:
  void DoDataExchange(CDataExchange* pDX) override;

  DECLARE_MESSAGE_MAP()
};

#pragma warning(suppress: 26455)
CAboutDlg::CAboutDlg() : CDialog{CAboutDlg::IDD}
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CAboutDlg, CDialog) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
END_MESSAGE_MAP()

#pragma warning(suppress: 26455)
CToastDlg::CToastDlg(CWnd* pParent) : CDialog{CToastDlg::IDD, pParent},
                                      m_nAnimationStyle{0},
                                      m_nBackgroundStyle{0},
                                      m_nPopupPosition{0},
                                      m_bHTML{FALSE},
                                      m_bTransparent{FALSE},
                                      m_bReuse{FALSE},
                                      m_bImage{FALSE},
                                      m_bOnlyCloseOnUser{FALSE},
                                      m_hIcon{AfxGetApp()->LoadIcon(IDR_MAINFRAME)},
                                      m_pToaster{nullptr}
{
}

void CToastDlg::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
  DDX_CBIndex(pDX, IDC_ANIMATIONSTYLE, m_nAnimationStyle);
  DDX_CBIndex(pDX, IDC_BACKGROUND_STYLE, m_nBackgroundStyle);
  DDX_CBIndex(pDX, IDC_POPUP_POSITION, m_nPopupPosition);
  DDX_Check(pDX, IDC_HTML, m_bHTML);
  DDX_Check(pDX, IDC_TRANSPARENT, m_bTransparent);
  DDX_Check(pDX, IDC_REUSE, m_bReuse);
  DDX_Check(pDX, IDC_IMAGE, m_bImage);
  DDX_Check(pDX, IDC_ONLY_CLOSE_ON_USER , m_bOnlyCloseOnUser);
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CToastDlg, CDialog) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_PAINT()
  ON_WM_QUERYDRAGICON()
  ON_WM_DESTROY()
  ON_BN_CLICKED(IDC_HIDE, &CToastDlg::OnHide)
  ON_BN_CLICKED(IDC_SHOW, &CToastDlg::OnShow)
END_MESSAGE_MAP()

BOOL CToastDlg::OnInitDialog()
{
  __super::OnInitDialog();

  SetIcon(m_hIcon, TRUE);
  SetIcon(m_hIcon, FALSE);

#ifdef CTOASTERWND_SCITER_SUPPORT
  HMODULE hSciter{LoadLibrary(_T("sciter.dll"))};
  const bool bSciterAvailable{hSciter != nullptr};
  if (bSciterAvailable)
    FreeLibrary(hSciter);
  GetDlgItem(IDC_HTML)->EnableWindow(bSciterAvailable);
#else
  GetDlgItem(IDC_HTML)->EnableWindow(FALSE);
#endif //#ifdef CTOASTERWND_SCITER_SUPPORT

  return TRUE;
}

#pragma warning(suppress: 26434)
void CToastDlg::OnPaint()
{
  if (IsIconic())
  {
    CPaintDC dc(this);
#pragma warning(suppress: 26490)
    SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);
    const int cxIcon{GetSystemMetrics(SM_CXICON)};
    const int cyIcon{GetSystemMetrics(SM_CYICON)};
    CRect rect;
    GetClientRect(&rect);
    const int x{(rect.Width() - cxIcon + 1) / 2};
    const int y{(rect.Height() - cyIcon + 1) / 2};
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
    __super::OnPaint();
}

#pragma warning(suppress: 26434 26440)
HCURSOR CToastDlg::OnQueryDragIcon()
{
#pragma warning(suppress: 26473)
  return static_cast<HCURSOR>(m_hIcon);
}

#pragma warning(suppress: 26434)
void CToastDlg::OnDestroy()
{
  //Kill the toaster
  if (m_pToaster != nullptr)
  {
    m_pToaster->Close();
    m_pToaster = nullptr;
  }

  //let the base class do its thing
  __super::OnDestroy();
}

void CToastDlg::OnHide()
{
  //Destroy the toast if visible
  if (m_pToaster != nullptr)
    m_pToaster->Hide();
}

void CToastDlg::OnShow()
{
  if (!UpdateData(TRUE))
    return;

  //Destroy any window currently created if we are not reusing instances
  if (m_pToaster && !m_bReuse)
  {
    m_pToaster->Close();
    m_pToaster = nullptr;
  }
  
  //Create some toast!
  CString sText;
  if (m_bHTML)
  {
    sText = _T("\
<html>\
<style>\
 html {\
  font:system;\
  background:window;\
  }\
 body {\
  padding:0;\
  margin:2pt;\
  }\
</style>\
  <head>\
  </head>\
  <body>\
   <p><a id=\"icon\" href=\"icon\"><img src=\"res:logo.jpg\" align=\"left\"></a>&nbsp;\
   <a href id=\"titletext\">It's Toast!!</a>&nbsp;\
   <button id=\"closebutton\">Close</button></p>\
   <a href id=\"bodytext\">This is a simple example of using the CToasterWnd class in a sample MFC app using Sciter HTML</a>\
  </body>\
</html>");
  }
  else
  {
    sText = _T("This is a simple example of using the CToasterWnd class in a sample MFC app");
    //sText = _T("Line 1\nLine 2\nLine 3 is also a long line and will normally wrap\nLine 4 which is a long line and will probably scroll\nLine 5\nLine 6");
    //sText = _T("Line 1\nLine 2\nLine 3\nLine 4\nLine 5\nLine 6");
  }
  BOOL bNewToaster{FALSE};
  if (m_pToaster == nullptr)
  {
#pragma warning(suppress: 26409)
    m_pToaster = new CDemoToasterWnd;
    m_pToaster->m_sTitle = _T("It's Toast!!");
    m_pToaster->m_sText = sText;
    bNewToaster = TRUE;
    if (!m_bHTML)
    {
      //Determine if we should show an image in the toast window
      if (m_bImage)
      {
        //As an example, load up a logo.png from the exe directory
        CString sLogo;
        const DWORD dwGMFN{GetModuleFileName(nullptr, sLogo.GetBuffer(_MAX_PATH), _MAX_PATH)};
        sLogo.ReleaseBuffer();
        if (dwGMFN == 0)
        {
          delete m_pToaster;
          m_pToaster = nullptr;
          return;
        }
        CString sDrive;
        CString sDir;
        _tsplitpath_s(sLogo, sDrive.GetBuffer(_MAX_DRIVE), _MAX_DRIVE, sDir.GetBuffer(_MAX_DIR), _MAX_DIR, nullptr, 0, nullptr, 0);
        sDir.ReleaseBuffer();
        sDrive.ReleaseBuffer();
        _tmakepath_s(sLogo.GetBuffer(_MAX_PATH), _MAX_PATH, sDrive, sDir, _T("logo"), _T("png"));
        if (FAILED(m_pToaster->LoadLogo(sLogo)))
        {
          m_pToaster = nullptr;
          return;
        }
      }
    }
  }

  //Set all the toaster properties
#ifdef CTOASTERWND_SCITER_SUPPORT
  m_pToaster->m_bHTML = m_bHTML ? true : false;
#endif  //#ifdef CTOASTERWND_SCITER_SUPPORT
  if (m_pToaster->m_TitleIcon)
#pragma warning(suppress: 26486)
    DestroyIcon(m_pToaster->m_TitleIcon);
  m_pToaster->m_TitleIcon = static_cast<HICON>(LoadImage(AfxGetResourceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR));
  m_pToaster->m_AnimationStyle = static_cast<CToasterWnd::AnimationStyle>(m_nAnimationStyle);
  m_pToaster->m_BackgroundStyle = static_cast<CToasterWnd::BackgroundStyle>(m_nBackgroundStyle);
  m_pToaster->m_PopupPosition = static_cast<CToasterWnd::PopupPosition>(m_nPopupPosition);
  m_pToaster->m_bOnlyCloseOnUser = m_bOnlyCloseOnUser ? true : false;

  int nXPixelsPerInch{96};
  int nYPixelsPerInch{96};
  HDC hScreen{::GetDC(nullptr)};
  if (hScreen != nullptr)
  {
    nXPixelsPerInch = GetDeviceCaps(hScreen, LOGPIXELSX);
    nYPixelsPerInch = GetDeviceCaps(hScreen, LOGPIXELSY);
    ::ReleaseDC(nullptr, hScreen);
  }

  //Use a slightly bigger window if we want to show some HTML
  if (m_bHTML)
  {
  #ifdef CTOASTERWND_SCITER_SUPPORT
    m_pToaster->m_nHeight = 110 * nYPixelsPerInch / 96;
    m_pToaster->m_nWidth = 185 * nXPixelsPerInch / 96;
  #endif  //#ifdef CTOASTERWND_SCITER_SUPPORT
  }
  else
  {
    m_pToaster->m_nHeight = 94 * nYPixelsPerInch / 96;
    m_pToaster->m_nWidth = 150 * nXPixelsPerInch / 96;
  }
  m_pToaster->m_bTransparent = m_bTransparent ? true : false;
  
  if (bNewToaster)
  {
    ASSERT(m_pToaster);
    if (!m_pToaster->Show())
    {
      //Note we do not need to delete m_pToaster because CToasterWnd is self deleting
      m_pToaster = nullptr;
    }
  }  
  else
  {
    //Just popup the already created toaster window
    m_pToaster->Popup();
  }
}
