#pragma once

#include "ToasterWnd.h"

class CDemoToasterWnd : public CToasterWnd
{
protected:
  void OnBodyTextClicked() override
  {
    AfxMessageBox(_T("Body text clicked!"));
  }

  void OnTitleTextClicked() override
  {
    AfxMessageBox(_T("Title text clicked!"));
  }

  void OnIconClicked() override
  {
    AfxMessageBox(_T("Icon clicked!"));
  }

#pragma warning(suppress: 26440)
  void OnCloseToast(bool /*bButton*/) override
  {
    TRACE(_T("CToasterWnd closing\n"));
  }

  void OnStateChange() noexcept override
  {
    //If a toast has completed popping up, do a message beep
    if (GetAnimationState() == CToasterWnd::AnimationState::Showing)
      MessageBeep(MB_OK);
  }
};

class CToastDlg : public CDialog
{
public:
//Constructors / Destructors
  CToastDlg(CWnd* pParent = nullptr);

//Member variables
  enum { IDD = IDD_TOAST_DIALOG };
  int  m_nAnimationStyle;
  int  m_nBackgroundStyle;
  int  m_nPopupPosition;
  BOOL m_bHTML;
  BOOL m_bTransparent;
  BOOL m_bReuse;
  BOOL m_bImage;
  BOOL m_bOnlyCloseOnUser;

protected:
//Methods
  void DoDataExchange(CDataExchange* pDX) override;
  BOOL OnInitDialog() override;

//Member variables
  HICON m_hIcon;
  CToasterWnd* m_pToaster;

//Message handlers
  afx_msg void OnPaint();
  afx_msg HCURSOR OnQueryDragIcon();
  afx_msg void OnDestroy();
  afx_msg void OnHide();
  afx_msg void OnShow();

  DECLARE_MESSAGE_MAP()
};
